import { world, ItemStack, ItemTypes } from "@minecraft/server"
import { system } from "@minecraft/server";
//This prevents world crash
system.events.beforeWatchdogTerminate.subscribe(data => {
    data.cancel = true;
});

world.events.itemReleaseCharge.subscribe(ev => {
    //This is for multiplayer support
    for (const player of world.getPlayers()) {
        //Basic variables to get the player inventory and held item.
        let inv = player.getComponent('inventory').container
        //Our ItemStact to save our item. This also saves item data.
        const itemStack = inv.getItem(player.selectedSlot);
        //If the item we're holding is our spear, we run code.
        if (itemStack?.typeId === 'snf:talon_dagger') {
            var container = player.getComponent('inventory').container
            //The new item to be given.
            var newItem = new ItemStack(ItemTypes?.get("snf:talon_dagger"));
            var oldItem = container?.getItem(player.selectedSlot)
            //Here's that tag!
            player.removeTag("talon_dagger")
        }
        //We subscribe a tick event to detect when we have the tag and if the item has durability less than the max.
        let e = world.events.tick.subscribe(data => {
            if (player.hasTag("talon_dagger") && itemStack?.typeId === 'snf:talon_dagger' && itemStack?.getComponent("durability").damage <= 200) {
                player.removeTag("talon_dagger")
                //This gives our saved item (newItem) +1 durability each time we pick it up.
                newItem.getComponent("durability").damage = oldItem.getComponent("durability").damage + 1;
                container.setItem(player.selectedSlot, newItem);
                //When we don't have the tag, we stop the tick event.
                if (!player.hasTag("talon_dagger")) {
                    world.events.tick.unsubscribe(e);
                }
            }
        })
    }
})